## vboot-utils 0~R63-10032.B

=== debian/changelog ===
vboot-utils (0~R63-10032.B-3) unstable; urgency=medium

  * Move git repository to salsa.debian.org.
  * Make build logs verbose to include the full command line.
  * Protect dh_override_auto_test with check of nocheck in DEB_BUILD_OPTIONS.
  * Bump Standards-Version to 4.1.3.
  * Update my name in Uploaders.

 -- Raphaël Hertzog <hertzog@debian.org>  Tue, 06 Feb 2018 16:29:11 +0100

vboot-utils (0~R63-10032.B-2) unstable; urgency=medium

  * Add a patch to fix futility bdb on 32 bits architectures (Closes: #881997)

 -- Sophie Brun <sophie@freexian.com>  Mon, 20 Nov 2017 14:19:32 +0100

vboot-utils (0~R63-10032.B-1) unstable; urgency=medium

  * Fix debian/watch
  * New upstream version 0~R63-10032.B
  * Build against openssl 1.1 (Closes: #835801)
  * Remove useless patch 0001-use-zu-as-appropriate-for-size_t (fixed
    upstream)
  * Update debian/copyright
  * Remove useless patch 0009-drop-failing-test.patch
  * Add a patch to fix failing tests-show-contents
  * Bump Standards-version to 4.1.1: update Priority to optional, use https
  * Fix perms for usr/share/vboot/bin/common_minimal.sh

 -- Sophie Brun <sophie@freexian.com>  Thu, 16 Nov 2017 09:21:28 +0100
