=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_build:
	dh_auto_build -- V=1

override_dh_auto_install:
	$(MAKE) V=1 DESTDIR=$$(pwd)/debian/vboot-utils/usr install
	mkdir -p $$(pwd)/debian/cgpt/usr/bin
	mv -t $$(pwd)/debian/cgpt/usr/bin \
	        $$(pwd)/debian/vboot-utils/usr/bin/cgpt
	mkdir -p $$(pwd)/debian/vboot-kernel-utils/usr/bin
	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
	        $$(pwd)/debian/vboot-utils/usr/bin/vbutil_kernel
	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
	        $$(pwd)/debian/vboot-utils/usr/bin/futility
	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
	        $$(pwd)/debian/vboot-utils/usr/bin/futility_s
	# vboot_host.pc is useless without the static library (which
	# we could install with "make install-dev" but we currently don't)
	rm -f debian/vboot-utils/usr/lib/pkgconfig/vboot_host.pc
	rmdir --ignore-fail-on-non-empty -p debian/vboot-utils/usr/lib/pkgconfig

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make runtests V=1
endif

%:
	dh $@ --parallel

override_dh_fixperms:
	dh_fixperms
	chmod 755 debian/vboot-utils/usr/share/vboot/bin/common_minimal.sh
