## vboot-utils 0~R81

=== Makefile ===
--- 
+++ 
@@ -103,6 +103,8 @@
 
 ifeq (${ARCH},armv7l)
   override ARCH := arm
+else ifneq (,$(filter aarch64 arm64,${ARCH}))
+  override ARCH := arm
 else ifeq (${ARCH},i386)
   override ARCH := x86
 else ifeq (${ARCH},i686)
@@ -133,39 +135,37 @@
 # permit a calling script or Makefile to set these.
 #
 # Flag ordering: arch, then -f, then -m, then -W
-DEBUG_FLAGS := $(if ${DEBUG},-g -O0,-Os)
+DEBUG_FLAGS := $(if ${DEBUG},-g -O0,-g -Os)
 WERROR := -Werror
-COMMON_FLAGS := -nostdinc -pipe \
-	-ffreestanding -fno-builtin -fno-stack-protector \
-	${WERROR} -Wall -Wstrict-prototypes ${DEBUG_FLAGS}
+FIRMWARE_FLAGS := -nostdinc -ffreestanding -fno-builtin -fno-stack-protector
+COMMON_FLAGS := -pipe ${WERROR} -Wall -Wstrict-prototypes -Wtype-limits \
+	-Wundef -Wmissing-prototypes -Wno-trigraphs -Wredundant-decls -Wshadow \
+	-Wwrite-strings -Wstrict-aliasing -Wdate-time -Wno-unknown-warning \
+	-Wno-address-of-packed-member -ffunction-sections -fdata-sections \
+	-Wimplicit-fallthrough -Wformat -Wno-format-security ${DEBUG_FLAGS}
 
 # Note: FIRMWARE_ARCH is defined by the Chromium OS ebuild.
-ifeq (${FIRMWARE_ARCH}, arm)
-CC ?= armv7a-cros-linux-gnueabi-gcc
-CFLAGS ?= -march=armv5 \
-	-fno-common -ffixed-r8 \
-	-mfloat-abi=hard -marm -mabi=aapcs-linux -mno-thumb-interwork \
-	${COMMON_FLAGS}
-else ifeq (${FIRMWARE_ARCH}, x86)
+ifeq (${FIRMWARE_ARCH},arm)
+CC ?= armv7a-cros-linux-gnueabihf-gcc
+CFLAGS ?= -march=armv5 -fno-common -ffixed-r8 -mfloat-abi=hard -marm
+	-mabi=aapcs-linux -mno-thumb-interwork ${FIRMWARE_FLAGS} ${COMMON_FLAGS}
+else ifeq (${FIRMWARE_ARCH},x86)
 CC ?= i686-pc-linux-gnu-gcc
 # Drop -march=i386 to permit use of SSE instructions
-CFLAGS ?= \
-	-ffunction-sections -fvisibility=hidden -fno-strict-aliasing \
-	-fomit-frame-pointer -fno-toplevel-reorder -fno-dwarf2-cfi-asm \
-	-mpreferred-stack-boundary=2 \
-	${COMMON_FLAGS}
-else ifeq (${FIRMWARE_ARCH}, x86_64)
-CFLAGS ?= ${COMMON_FLAGS} \
-	-fvisibility=hidden -fno-strict-aliasing -fomit-frame-pointer
+CFLAGS ?= -fvisibility=hidden -fomit-frame-pointer \
+	-fno-toplevel-reorder -fno-dwarf2-cfi-asm -mpreferred-stack-boundary=2 \
+	${FIRMWARE_FLAGS} ${COMMON_FLAGS}
+else ifeq (${FIRMWARE_ARCH},x86_64)
+CFLAGS ?= ${FIRMWARE_FLAGS} ${COMMON_FLAGS} -fvisibility=hidden \
+	-fomit-frame-pointer
 else
 # FIRMWARE_ARCH not defined; assuming local compile.
 CC ?= gcc
-CFLAGS += -DCHROMEOS_ENVIRONMENT -Wall ${WERROR} ${DEBUG_FLAGS}
-endif
-
-ifneq (${CUSTOM_MUSIC},)
-CFLAGS += -DCUSTOM_MUSIC
-endif
+CFLAGS += -DCHROMEOS_ENVIRONMENT ${COMMON_FLAGS}
+endif
+
+# Needs -Wl because LD is actually set to CC by default.
+LDFLAGS ?= -Wl,--gc-sections
 
 ifneq (${DEBUG},)
 CFLAGS += -DVBOOT_DEBUG
@@ -179,17 +179,55 @@
 CFLAGS += -DFORCE_LOGGING_ON=${FORCE_LOGGING_ON}
 endif
 
-ifneq (${PD_SYNC},)
-CFLAGS += -DPD_SYNC
-endif
-
-ifneq (${USE_MTD},)
-CFLAGS += -DUSE_MTD
-LDLIBS += -lmtdutils
-endif
-
 ifneq (${TPM2_MODE},)
 CFLAGS += -DTPM2_MODE
+endif
+
+# Enable USB boot when switching to dev mode
+ifneq ($(filter-out 0,${USB_BOOT_ON_DEV}),)
+CFLAGS += -DUSB_BOOT_ON_DEV=1
+else
+CFLAGS += -DUSB_BOOT_ON_DEV=0
+endif
+
+# EC software sync is slow to update. Enable warning screen display.
+ifneq ($(filter-out 0,${EC_SLOW_UPDATE}),)
+CFLAGS += -DEC_SLOW_UPDATE=1
+else
+CFLAGS += -DEC_SLOW_UPDATE=0
+endif
+
+# Enable EC early firmware selection.
+ifneq ($(filter-out 0,${EC_EFS}),)
+CFLAGS += -DEC_EFS=1
+else
+CFLAGS += -DEC_EFS=0
+endif
+
+# Some tests need to be disabled when using mocked_secdata_tpm.
+ifneq (${MOCK_TPM},)
+CFLAGS += -DMOCK_TPM
+endif
+
+# LEGACY_MENU_UI controls whether to enable legacy menu UI, which is used with
+# devices that don't have a keyboard (detachables).
+# Pass LEGACY_MENU_UI= (or =0) to make to disable feature.
+ifneq ($(filter-out 0,${LEGACY_MENU_UI}),)
+CFLAGS += -DLEGACY_MENU_UI=1
+else
+CFLAGS += -DLEGACY_MENU_UI=0
+endif
+
+# enable all features during local compile (permits testing)
+ifeq (${FIRMWARE_ARCH},)
+DIAGNOSTIC_UI := 1
+endif
+
+# pass DIAGNOSTIC_UI= (or =0) to make to disable feature
+ifneq ($(filter-out 0,${DIAGNOSTIC_UI}),)
+CFLAGS += -DDIAGNOSTIC_UI=1
+else
+CFLAGS += -DDIAGNOSTIC_UI=0
 endif
 
 # NOTE: We don't use these files but they are useful for other packages to
@@ -233,6 +271,18 @@
 ifneq (${STATIC},)
 LDFLAGS += -static
 PKG_CONFIG += --static
+endif
+
+ifneq (${FUZZ_FLAGS},)
+CFLAGS += ${FUZZ_FLAGS}
+endif
+
+# Optional Libraries
+LIBZIP_VERSION := $(shell ${PKG_CONFIG} --modversion libzip 2>/dev/null)
+HAVE_LIBZIP := $(if ${LIBZIP_VERSION},1)
+ifneq (${HAVE_LIBZIP},)
+  CFLAGS += -DHAVE_LIBZIP $(shell ${PKG_CONFIG} --cflags libzip)
+  LIBZIP_LIBS := $(shell ${PKG_CONFIG} --libs libzip)
 endif
 
 # Determine QEMU architecture needed, if any
@@ -275,7 +325,7 @@
 
 # Default target.
 .PHONY: all
-all: fwlib fwlib2x fwlib20 fwlib21 \
+all: $(if ${NO_BUILD_TOOLS},,fwlib fwlib2x fwlib20 fwlib21 tlcl) \
 	$(if ${FIRMWARE_ARCH},,host_stuff) \
 	$(if ${COV},coverage)
 
@@ -314,27 +364,14 @@
 # Vboot 2.1 (not yet ready - see firmware/README)
 FWLIB21 = ${BUILD}/vboot_fw21.a
 
-# Static library containing firmware APIs for common boot flow
-BDBLIB = ${BUILD}/bdb.a
-
-# Firmware library sources needed by VbInit() call
-VBINIT_SRCS = \
-	firmware/lib/vboot_common_init.c \
-	firmware/lib/vboot_nvstorage.c \
-	firmware/lib/region-init.c \
-
-# Additional firmware library sources needed by VbSelectFirmware() call
-VBSF_SRCS = \
-	firmware/lib/vboot_common.c \
-	firmware/lib/region-fw.c \
+# Separate TPM lightweight command library (TLCL)
+TLCL = ${BUILD}/tlcl.a
 
 # Additional firmware library sources needed by VbSelectAndLoadKernel() call
-VBSLK_SRCS = \
+FWLIB_SRCS = \
 	firmware/lib/cgptlib/cgptlib.c \
 	firmware/lib/cgptlib/cgptlib_internal.c \
 	firmware/lib/cgptlib/crc32.c \
-	firmware/lib/ec_sync.c \
-	firmware/lib/ec_sync_all.c \
 	firmware/lib/gpt_misc.c \
 	firmware/lib/utility_string.c \
 	firmware/lib/vboot_api_kernel.c \
@@ -342,19 +379,24 @@
 	firmware/lib/vboot_display.c \
 	firmware/lib/vboot_kernel.c \
 	firmware/lib/vboot_ui.c \
-	firmware/lib/vboot_ui_menu.c \
-	firmware/lib/region-kernel.c \
+	firmware/lib/vboot_ui_common.c \
+	firmware/lib/vboot_ui_menu.c
 
 # Code common to both vboot 2.0 (old structs) and 2.1 (new structs)
 FWLIB2X_SRCS = \
 	firmware/2lib/2api.c \
+	firmware/2lib/2auxfw_sync.c \
 	firmware/2lib/2common.c \
+	firmware/2lib/2context.c \
 	firmware/2lib/2crc8.c \
+	firmware/2lib/2ec_sync.c \
+	firmware/2lib/2gbb.c \
 	firmware/2lib/2misc.c \
 	firmware/2lib/2nvstorage.c \
 	firmware/2lib/2rsa.c \
-	firmware/2lib/2secdata.c \
-	firmware/2lib/2secdatak.c \
+	firmware/2lib/2secdata_firmware.c \
+	firmware/2lib/2secdata_fwmp.c \
+	firmware/2lib/2secdata_kernel.c \
 	firmware/2lib/2sha1.c \
 	firmware/2lib/2sha256.c \
 	firmware/2lib/2sha512.c \
@@ -363,74 +405,9 @@
 	firmware/2lib/2hmac.c
 
 FWLIB20_SRCS = \
-	firmware/lib20/api.c \
 	firmware/lib20/api_kernel.c \
-	firmware/lib20/common.c \
 	firmware/lib20/kernel.c \
 	firmware/lib20/misc.c \
 	firmware/lib20/packed_key.c
 
 FWLIB21_SRCS = \
-	firmware/lib21/api.c \
-	firmware/lib21/common.c \
-	firmware/lib21/misc.c \
-	firmware/lib21/packed_key.c
-
-BDBLIB_SRCS = \
-	firmware/bdb/bdb.c \
-	firmware/bdb/ecdsa.c \
-	firmware/bdb/misc.c \
-	firmware/bdb/rsa.c \
-	firmware/bdb/secrets.c \
-	firmware/bdb/sha.c \
-	firmware/bdb/stub.c \
-	firmware/bdb/nvm.c
-
-# TPM lightweight command library
-ifeq (${TPM2_MODE},)
-TLCL_SRCS = \
-	firmware/lib/tpm_lite/tlcl.c
-else
-TLCL_SRCS = \
-	firmware/lib/tpm2_lite/tlcl.c \
-	firmware/lib/tpm2_lite/marshaling.c
-endif
-TLCL_OBJS_FOR_TEST = $(TLCL_SRCS:%.c=${BUILD}/%_for_test.o)
-
-# Support real TPM unless BIOS sets MOCK_TPM
-ifeq (${MOCK_TPM},)
-VBINIT_SRCS += \
-	firmware/lib/rollback_index.c \
-	${TLCL_SRCS}
-else
-VBINIT_SRCS += \
-	firmware/lib/mocked_rollback_index.c \
-	firmware/lib/tpm_lite/mocked_tlcl.c
-endif
-
-ifeq (${FIRMWARE_ARCH},)
-# Include BIOS stubs in the firmware library when compiling for host
-# TODO: split out other stub funcs too
-VBINIT_SRCS += \
-	firmware/stub/tpm_lite_stub.c \
-	firmware/stub/vboot_api_stub_init.c \
-	firmware/stub/vboot_api_stub_region.c
-
-VBSLK_SRCS += \
-	firmware/stub/vboot_api_stub.c \
-	firmware/stub/vboot_api_stub_disk.c \
-	firmware/stub/vboot_api_stub_stream.c
-
-FWLIB2X_SRCS += \
-	firmware/2lib/2stub.c
-
-endif
-
-VBSF_SRCS += ${VBINIT_SRCS}
-FWLIB_SRCS += ${VBSF_SRCS} ${VBSLK_SRCS}
-
-VBINIT_OBJS = ${VBINIT_SRCS:%.c=${BUILD}/%.o}
-VBSF_OBJS = ${VBSF_SRCS:%.c=${BUILD}/%.o}
-ALL_OBJS +=  ${VBINIT_OBJS} ${VBSF_OBJS}
-
-FWLIB_OBJS = ${FWLIB_SRCS:%.c=${BUILD}/%.o}
