## vboot-utils 0~R81-12871.B

=== debian/changelog ===
vboot-utils (0~R81-12871.B-1) unstable; urgency=medium

  * Update debian/watch
  * New upstream version 0~R81-12871.B
  * Refresh patches
  * Build with clang and libfuzzer
  * d/rules: remove futility_s mention (no longer exists)
  * Add a patch to remove -Werror flag
  * Use debhelper-compat 12
  * Remove useless python in build-dep (Closes: #938769)
  * Add missing build-dep bc required for tests
  * Update debian/copyright
  * Add missing flags pie
  * Bump Standards-Version to 4.5.0

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 12 Feb 2020 15:14:54 +0100
