=== debian/control ===
--- 
+++ 
@@ -1,19 +1,21 @@
 Source: vboot-utils
 Section: admin
 Priority: optional
-Maintainer: Sophie Brun <sophie@freexian.com>
+Maintainer: Sophie Brun <sophie@offensive-security.com>
 Uploaders: Raphaël Hertzog <hertzog@debian.org>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper-compat (= 12),
+               clang-9,
+               libfuzzer-9-dev,
                liblzma-dev,
                libssl-dev,
                libyaml-dev,
                pkg-config,
                uuid-dev,
-# tests/bitmaps/TestBmpBlock.py
-               python,
+# tests/subprocess_tests.c
+               bc,
 # tests/external_rsa_signer.sh
                openssl
-Standards-Version: 4.1.3
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/debian/vboot-utils.git
 Vcs-Browser: https://salsa.debian.org/debian/vboot-utils
 Homepage: https://chromium.googlesource.com/chromiumos/platform/vboot_reference
