=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export CC = clang-9
 
 override_dh_auto_build:
 	dh_auto_build -- V=1
@@ -15,8 +16,6 @@
 	        $$(pwd)/debian/vboot-utils/usr/bin/vbutil_kernel
 	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
 	        $$(pwd)/debian/vboot-utils/usr/bin/futility
-	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
-	        $$(pwd)/debian/vboot-utils/usr/bin/futility_s
 	# vboot_host.pc is useless without the static library (which
 	# we could install with "make install-dev" but we currently don't)
 	rm -f debian/vboot-utils/usr/lib/pkgconfig/vboot_host.pc
@@ -28,7 +27,7 @@
 endif
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_fixperms:
 	dh_fixperms
