## vboot-utils 0~R88

=== Makefile ===
--- 
+++ 
@@ -43,7 +43,7 @@
 
 # Stuff for 'make install'
 INSTALL = install
-DESTDIR = /usr/local
+DESTDIR = /
 LIBDIR ?= lib
 
 # Default values
@@ -56,17 +56,6 @@
 #  US_DIR = shared data directory (for static content like devkeys)
 #  DF_DIR = utility defaults directory
 #  VB_DIR = vboot binary directory for dev-mode-only scripts
-ifeq (${MINIMAL},)
-# Host install just puts everything where it's told
-UB_DIR=${DESTDIR}/bin
-UL_DIR=${DESTDIR}/${LIBDIR}
-ULP_DIR=${UL_DIR}/pkgconfig
-UI_DIR=${DESTDIR}/include/vboot
-US_DIR=${DESTDIR}/share/vboot
-DF_DIR=${DESTDIR}/default
-VB_DIR=${DESTDIR}/bin
-else
-# Target install puts things into different places
 UB_DIR=${DESTDIR}/usr/bin
 UL_DIR=${DESTDIR}/usr/${LIBDIR}
 ULP_DIR=${UL_DIR}/pkgconfig
@@ -74,10 +63,12 @@
 US_DIR=${DESTDIR}/usr/share/vboot
 DF_DIR=${DESTDIR}/etc/default
 VB_DIR=${US_DIR}/bin
-endif
 
 # Where to install the (exportable) executables for testing?
 TEST_INSTALL_DIR = ${BUILD}/install_for_test
+
+# Set when installing into the SDK instead of building for a board sysroot.
+SDK_BUILD ?=
 
 # Verbose? Use V=1
 ifeq (${V},)
@@ -96,7 +87,7 @@
 HOST_ARCH ?= ${_machname}
 
 # ARCH and/or FIRMWARE_ARCH are defined by the Chromium OS ebuild.
-# Pick a sane target architecture if none is defined.
+# Pick a valid target architecture if none is defined.
 ifeq (${ARCH},)
   ARCH := ${HOST_ARCH}
 endif
@@ -113,9 +104,15 @@
   override ARCH := x86_64
 endif
 
+ifneq ($(wildcard host/arch/${ARCH}/lib/crossystem_arch.c),)
+	CROSSYSTEM_ARCH_C := host/arch/${ARCH}/lib/crossystem_arch.c
+else
+	CROSSYSTEM_ARCH_C := host/arch/stub/lib/crossystem_arch.c
+endif
+
 # FIRMWARE_ARCH is only defined by the Chromium OS ebuild if compiling
-# for a firmware target (such as u-boot or depthcharge). It must map
-# to the same consistent set of architectures as the host.
+# for a firmware target (coreboot or depthcharge). It must map to the same
+# consistent set of architectures as the host.
 ifeq (${FIRMWARE_ARCH},i386)
   override FIRMWARE_ARCH := x86
 else ifeq (${FIRMWARE_ARCH},amd64)
@@ -126,15 +123,6 @@
 
 # Provide default CC and CFLAGS for firmware builds; if you have any -D flags,
 # please add them after this point (e.g., -DVBOOT_DEBUG).
-#
-# TODO(crosbug.com/16808) We hard-code u-boot's compiler flags here just
-# temporarily. As we are still investigating which flags are necessary for
-# maintaining a compatible ABI, etc. between u-boot and vboot_reference.
-#
-# As a first step, this makes the setting of CC and CFLAGS here optional, to
-# permit a calling script or Makefile to set these.
-#
-# Flag ordering: arch, then -f, then -m, then -W
 DEBUG_FLAGS := $(if ${DEBUG},-g -O0,-g -Os)
 WERROR := -Werror
 FIRMWARE_FLAGS := -nostdinc -ffreestanding -fno-builtin -fno-stack-protector
@@ -144,7 +132,8 @@
 	-Wno-address-of-packed-member -ffunction-sections -fdata-sections \
 	-Wimplicit-fallthrough -Wformat -Wno-format-security ${DEBUG_FLAGS}
 
-# Note: FIRMWARE_ARCH is defined by the Chromium OS ebuild.
+# FIRMWARE_ARCH is defined if compiling for a firmware target
+# (coreboot or depthcharge).
 ifeq (${FIRMWARE_ARCH},arm)
 CC ?= armv7a-cros-linux-gnueabihf-gcc
 CFLAGS ?= -march=armv5 -fno-common -ffixed-r8 -mfloat-abi=hard -marm
@@ -165,7 +154,7 @@
 endif
 
 # Needs -Wl because LD is actually set to CC by default.
-LDFLAGS ?= -Wl,--gc-sections
+LDFLAGS += -Wl,--gc-sections
 
 ifneq (${DEBUG},)
 CFLAGS += -DVBOOT_DEBUG
@@ -183,18 +172,11 @@
 CFLAGS += -DTPM2_MODE
 endif
 
-# Enable USB boot when switching to dev mode
-ifneq ($(filter-out 0,${USB_BOOT_ON_DEV}),)
-CFLAGS += -DUSB_BOOT_ON_DEV=1
-else
-CFLAGS += -DUSB_BOOT_ON_DEV=0
-endif
-
-# EC software sync is slow to update. Enable warning screen display.
-ifneq ($(filter-out 0,${EC_SLOW_UPDATE}),)
-CFLAGS += -DEC_SLOW_UPDATE=1
-else
-CFLAGS += -DEC_SLOW_UPDATE=0
+# Enable boot from external disk when switching to dev mode
+ifneq ($(filter-out 0,${BOOT_EXTERNAL_ON_DEV}),)
+CFLAGS += -DBOOT_EXTERNAL_ON_DEV=1
+else
+CFLAGS += -DBOOT_EXTERNAL_ON_DEV=0
 endif
 
 # Enable EC early firmware selection.
@@ -207,6 +189,27 @@
 # Some tests need to be disabled when using mocked_secdata_tpm.
 ifneq (${MOCK_TPM},)
 CFLAGS += -DMOCK_TPM
+endif
+
+# TPM2_SIMULATOR indicates whether the TPM2 simulator feature is enable or not.
+ifneq ($(filter-out 0,${TPM2_SIMULATOR}),)
+CFLAGS += -DTPM2_SIMULATOR=1
+else
+CFLAGS += -DTPM2_SIMULATOR=0
+endif
+
+# DETACHABLE indicates whether the device is a detachable or not.
+ifneq ($(filter-out 0,${DETACHABLE}),)
+CFLAGS += -DDETACHABLE=1
+else
+CFLAGS += -DDETACHABLE=0
+endif
+
+# Enable the menu-based user interface.
+ifneq ($(filter-out 0,${MENU_UI}),)
+CFLAGS += -DMENU_UI=1
+else
+CFLAGS += -DMENU_UI=0
 endif
 
 # LEGACY_MENU_UI controls whether to enable legacy menu UI, which is used with
@@ -218,16 +221,18 @@
 CFLAGS += -DLEGACY_MENU_UI=0
 endif
 
-# enable all features during local compile (permits testing)
-ifeq (${FIRMWARE_ARCH},)
-DIAGNOSTIC_UI := 1
-endif
-
 # pass DIAGNOSTIC_UI= (or =0) to make to disable feature
 ifneq ($(filter-out 0,${DIAGNOSTIC_UI}),)
 CFLAGS += -DDIAGNOSTIC_UI=1
 else
 CFLAGS += -DDIAGNOSTIC_UI=0
+endif
+
+# Confirm physical presence using keyboard
+ifneq ($(filter-out 0,${PHYSICAL_PRESENCE_KEYBOARD}),)
+CFLAGS += -DPHYSICAL_PRESENCE_KEYBOARD=1
+else
+CFLAGS += -DPHYSICAL_PRESENCE_KEYBOARD=0
 endif
 
 # NOTE: We don't use these files but they are useful for other packages to
@@ -325,8 +330,9 @@
 
 # Default target.
 .PHONY: all
-all: $(if ${NO_BUILD_TOOLS},,fwlib fwlib2x fwlib20 fwlib21 tlcl) \
-	$(if ${FIRMWARE_ARCH},,host_stuff) \
+all: fwlib futil utillib hostlib cgpt tlcl \
+	$(if ${SDK_BUILD},utils_sdk,utils_board) \
+	$(if $(filter x86_64,${ARCH}),$(if $(filter clang,${CC}),fuzzers)) \
 	$(if ${COV},coverage)
 
 ##############################################################################
@@ -346,7 +352,7 @@
 # TPM commands and various external functions that are provided by the BIOS.
 ifeq (${FIRMWARE_ARCH},)
 INCLUDES += -Ihost/include -Ihost/lib/include
-INCLUDES += -Ihost/lib21/include -Ifirmware/lib21/include
+INCLUDES += -Ihost/lib21/include
 endif
 
 # Firmware library, used by the other firmware components (depthcharge,
@@ -354,45 +360,23 @@
 # this source tree locally and link to it directly.
 FWLIB = ${BUILD}/vboot_fw.a
 
-# Smaller firmware library common to all vboot 2.x, used only for
-# 1) compile-time tests of the public API or
-# 2) linking with an actual 2.0 or 2.1 implementation
-FWLIB2X = ${BUILD}/vboot_fw2x.a
-
-# Vboot 2.0 (deprecated - see firmware/README)
-FWLIB20 = ${BUILD}/vboot_fw20.a
-# Vboot 2.1 (not yet ready - see firmware/README)
-FWLIB21 = ${BUILD}/vboot_fw21.a
-
 # Separate TPM lightweight command library (TLCL)
 TLCL = ${BUILD}/tlcl.a
 
-# Additional firmware library sources needed by VbSelectAndLoadKernel() call
 FWLIB_SRCS = \
-	firmware/lib/cgptlib/cgptlib.c \
-	firmware/lib/cgptlib/cgptlib_internal.c \
-	firmware/lib/cgptlib/crc32.c \
-	firmware/lib/gpt_misc.c \
-	firmware/lib/utility_string.c \
-	firmware/lib/vboot_api_kernel.c \
-	firmware/lib/vboot_audio.c \
-	firmware/lib/vboot_display.c \
-	firmware/lib/vboot_kernel.c \
-	firmware/lib/vboot_ui.c \
-	firmware/lib/vboot_ui_common.c \
-	firmware/lib/vboot_ui_menu.c
-
-# Code common to both vboot 2.0 (old structs) and 2.1 (new structs)
-FWLIB2X_SRCS = \
 	firmware/2lib/2api.c \
 	firmware/2lib/2auxfw_sync.c \
 	firmware/2lib/2common.c \
 	firmware/2lib/2context.c \
 	firmware/2lib/2crc8.c \
+	firmware/2lib/2crypto.c \
 	firmware/2lib/2ec_sync.c \
 	firmware/2lib/2gbb.c \
+	firmware/2lib/2hmac.c \
+	firmware/2lib/2kernel.c \
 	firmware/2lib/2misc.c \
 	firmware/2lib/2nvstorage.c \
+	firmware/2lib/2recovery_reasons.c \
 	firmware/2lib/2rsa.c \
 	firmware/2lib/2secdata_firmware.c \
 	firmware/2lib/2secdata_fwmp.c \
@@ -401,13 +385,40 @@
 	firmware/2lib/2sha256.c \
 	firmware/2lib/2sha512.c \
 	firmware/2lib/2sha_utility.c \
+	firmware/2lib/2stub_hwcrypto.c \
 	firmware/2lib/2tpm_bootmode.c \
-	firmware/2lib/2hmac.c
-
-FWLIB20_SRCS = \
+	firmware/2lib/2ui.c \
+	firmware/2lib/2ui_screens.c \
+	firmware/lib/cgptlib/cgptlib.c \
+	firmware/lib/cgptlib/cgptlib_internal.c \
+	firmware/lib/cgptlib/crc32.c \
+	firmware/lib/gpt_misc.c \
+	firmware/lib/vboot_api_kernel.c \
+	firmware/lib/vboot_audio.c \
+	firmware/lib/vboot_kernel.c \
+	firmware/lib/vboot_ui_legacy.c \
+	firmware/lib/vboot_ui_legacy_clamshell.c \
+	firmware/lib/vboot_ui_legacy_menu.c \
+	firmware/lib/vboot_ui_legacy_wilco.c \
 	firmware/lib20/api_kernel.c \
 	firmware/lib20/kernel.c \
 	firmware/lib20/misc.c \
 	firmware/lib20/packed_key.c
 
-FWLIB21_SRCS = \
+# TPM lightweight command library
+ifeq (${TPM2_MODE},)
+TLCL_SRCS = \
+	firmware/lib/tpm_lite/tlcl.c
+else
+# TODO(apronin): tests for TPM2 case?
+TLCL_SRCS = \
+	firmware/lib/tpm2_lite/tlcl.c \
+	firmware/lib/tpm2_lite/marshaling.c
+endif
+
+# Support real TPM unless MOCK_TPM is set
+ifneq (${MOCK_TPM},)
+FWLIB_SRCS += \
+	firmware/lib/tpm_lite/mocked_tlcl.c
+endif
+
