## vboot-utils 0~R88-13597.B

=== debian/changelog ===
vboot-utils (0~R88-13597.B-1) unstable; urgency=medium

  [ Sophie Brun ]
  * Add a patch to fix reproducible build (Closes: #974863)
  * Upgrade to clang-11 (Closes: #974776)
  * Bump Standards-Version to 4.5.1 (no changes)
  * Use version=4 in debian/watch
  * New upstream version 0~R88-13597.B
  * Refresh patches

  [ Raphael Hertzog ]
  * Use libfuzzer-11-dev instead of libfuzzer-10-dev

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 01 Dec 2020 10:59:21 +0100

vboot-utils (0~R87-13505.B-1) unstable; urgency=medium

  * New upstream version 0~R87-13505.B
  * Refresh patches
  * Add a patch to not embed user and time in version (Closes: #971400)
  * Switch to clang 10 (Closes: #971402)
  * Remove override_dh_fixperms no longer needed
  * Update installation for new upstream release

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 27 Oct 2020 21:01:46 +0100
