=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: admin
 Priority: optional
 Maintainer: Sophie Brun <sophie@offensive-security.com>
-Uploaders: Raphaël Hertzog <hertzog@debian.org>
+Uploaders: Raphaël Hertzog <raphael@offensive-security.com>
 Build-Depends: debhelper-compat (= 12),
-               clang-9,
-               libfuzzer-9-dev,
+               clang-11,
+               libfuzzer-11-dev,
                liblzma-dev,
                libssl-dev,
                libyaml-dev,
@@ -15,7 +15,7 @@
                bc,
 # tests/external_rsa_signer.sh
                openssl
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Git: https://salsa.debian.org/debian/vboot-utils.git
 Vcs-Browser: https://salsa.debian.org/debian/vboot-utils
 Homepage: https://chromium.googlesource.com/chromiumos/platform/vboot_reference
