=== debian/rules ===
--- 
+++ 
@@ -1,13 +1,14 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export CC = clang-9
+export CC = clang-11
+export _machname = $(DEB_HOST_ARCH)
 
 override_dh_auto_build:
 	dh_auto_build -- V=1
 
 override_dh_auto_install:
-	$(MAKE) V=1 DESTDIR=$$(pwd)/debian/vboot-utils/usr install
+	$(MAKE) V=1 DESTDIR=$$(pwd)/debian/vboot-utils install
 	mkdir -p $$(pwd)/debian/cgpt/usr/bin
 	mv -t $$(pwd)/debian/cgpt/usr/bin \
 	        $$(pwd)/debian/vboot-utils/usr/bin/cgpt
@@ -20,6 +21,7 @@
 	# we could install with "make install-dev" but we currently don't)
 	rm -f debian/vboot-utils/usr/lib/pkgconfig/vboot_host.pc
 	rmdir --ignore-fail-on-non-empty -p debian/vboot-utils/usr/lib/pkgconfig
+	rm -f debian/vboot-utils/usr/lib/libvboot_host.a
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
@@ -28,7 +30,3 @@
 
 %:
 	dh $@
-
-override_dh_fixperms:
-	dh_fixperms
-	chmod 755 debian/vboot-utils/usr/share/vboot/bin/common_minimal.sh
